uulib-0.9.20: Haskell Utrecht Tools Library

Safe Haskell | Safe
Language | Haskell98

UU.Util.PermTree

# Documentation

data Perms p a Source

Constructors

Choice (Maybe a) [Branch p a] |

Instances

Functor (Perms p) Source |

data Branch p a Source

Constructors

forall x . Br (p x) (Perms p (x -> a)) |

Instances

Functor (Branch p) Source |

add :: Maybe a -> p a -> Perms p (a -> b) -> Perms p b Source

empty :: a -> Perms p a Source

(<$$>) :: (a -> b) -> p a -> Perms p b Source

(<$?>) :: (a -> b) -> (a, p a) -> Perms p b Source

(<||>) :: Perms p (a -> b) -> p a -> Perms p b Source

(<|?>) :: Perms p (a -> b) -> (a, p a) -> Perms p b Source